tarea04/encuesta/urls.py
from django.urls import path

from . import views

app_name = 'encuesta'

urlpatterns = [
    path('', views.index, name= 'index'),

    path('<int:pregunta_id>/', views.detalle, name='detalle'),

    path('<int:pregunta_id>/resultados/', views.resultados, name='resultados'),

    path('<int:pregunta_id>/voto/', views.votar, name='votar'),
]

tarea04/tarea04/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('encuesta/', include('encuesta.urls')),
    path('admin/', admin.site.urls),
]

tarea04/encuesta/models.py
from django.db import models

#Create your models here.
class Pregunta(models.Model):
    pregunta_texto = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published')

class Opcion(models.Model):
    pregunta = models.ForeignKey(Pregunta, on_delete=models.CASCADE)
    opcion_texto = models.CharField(max_length=200)
    votos= models.IntegerField(default=0)

# Create your models here.

tarea04/encuesta/views.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse

from .models import Opcion, Pregunta

def index(request):
    latest_question_list = Pregunta.objects.order_by('-pub_date')[:5]
    context = {'latest_question_list': latest_question_list}
    return render(request, 'index.html', context)

def detalle(request, pregunta_id):
    pregunta = get_object_or_404(Pregunta, pk=pregunta_id)
    return render(request, 'detalle.html', {'pregunta': pregunta})

def votar(request, pregunta_id):
    pregunta = get_object_or_404(Pregunta, pk=pregunta_id)
    try:
        selected_opcion = pregunta.opcion_set.get(pk=request.POST['opcion'])
    except (KeyError, Opcion.DoesNotExist):
        return render(request, 'detalle.html', {
            'pregunta': pregunta,
            'error_message' : "No has seleccionado una opcion",  
        })
    else:

        selected_opcion.votos +=1
        selected_opcion.save()
        return HttpResponseRedirect(reverse('encuesta:resultados', args=(pregunta.id,)))

def resultados(request, pregunta_id):
    pregunta = get_object_or_404(Pregunta, pk=pregunta_id)
    return render(request, 'resultados.html', {'pregunta': pregunta})

tarea04/encuesta/templates/detalle.html
<h1>{{ pregunta.pregunta_text }}</h1>
<h2 class="h2">CANDIDATOS PARA EL CONGRESO</h2>
<ul>
{% for opcion in pregunta.opcion_set.all %}
    <li class="opciones">{{ opcion.opcion_texto }} -- {{ opcion.votos }} voto{{ opcion.votos|pluralize }}</li>
{% endfor %}
</ul>

<h3 ><a href="{% url 'encuesta:resultados' pregunta.id %}">Votar de nuevo?</a></h3>
<h3><a href="{% url 'encuesta:index' %}">Ver preguntas</a></h3>
<style>
    .h2{
       color: rgb(221, 90, 204);
       text-align: justify;
       background-color:rgb(235, 241, 241);
    }
    .opciones{
        color: rgb(103, 103, 216);
        font-size: 20px;
        tab-size: 0.875em;
        font-family: Georgia, 'Times New Roman', Times, serif;
        line-height: 2.0em;
        margin: 20ox;
    }
    
 </style>

tarea04/encuesta/templates/index.html
<h1 class="Ele">ELECCIONES AL CONGRESO POR REGIÓN</h1>
   <style>
      .Ele{
         color: cornflowerblue;
         text-align: center;
         background-color:ghostwhite;
      }
      .encuesta{
         color:blue;
         font-size: 20px;
        tab-size: 0.875em;
        font-family: Georgia, 'Times New Roman', Times, serif;
        line-height: 1.5em;
        margin: 20ox;
      }
   </style>

{% if latest_question_list %}
   <ul>
   {% for pregunta in latest_question_list %}
      <li>
        <h3 class="encuesta"><a href="/encuesta/{{ pregunta.id }}/">{{ pregunta.pregunta_texto }}</a></h3> 
      </li>
   {% endfor %}
   </ul>
{% else %}
      <p>No hay registros.</p>
{% endif %}

tarea04/encuesta/templates/resultados.html
<h1>{{ pregunta.pregunta_texto }}</h1>

<style>
    .Ele{
       color: cornflowerblue;
       text-align: center;
       background-color:ghostwhite;
    }
    .index{
       color:yellow;
       
    }
    .opcion{
        color:rgb(255, 157, 157);
        font-size: 20px;
        tab-size: 0.875em;
        font-family: Georgia, 'Times New Roman', Times, serif;
        line-height: 2.0em;
        margin: 20ox;
    }
 </style>


{% if error_message %}<p><strong>{{ error_message }} </strong></p>{% endif %} 

<form action="{% url 'encuesta:votar' pregunta.id %}" method="post">
{% csrf_token %} 
{% for opcion in pregunta.opcion_set.all %} 
    <input type="radio" name="opcion" id="opcion{{ forloop.counter }}" value="{{ opcion.id }}">
    <label class="opcion" for="opcion{{ forloop.counter }}">{{ opcion.opcion_texto }}</label><br>
{% endfor %} 
<input type="submit" value="Votar">
</form>
<br/>
<h3><a href="{% url 'encuesta:index' %}">Ver preguntas</a></h3>